unit Unit1;

interface

uses
    Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
    Dialogs, StdCtrls;

type
    TForm1 = class(TForm)
        edFileName: TEdit;
        Label1: TLabel;
        btnParcourir: TButton;
        edDisplayData: TCheckBox;
        Button2: TButton;
        edData: TMemo;
        FOpenDialog: TOpenDialog;
        procedure Button2Click(Sender: TObject);
        procedure btnParcourirClick(Sender: TObject);
    private
    { Dclarations prives }
    public
    { Dclarations publiques }
    end;

var
    Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnParcourirClick(Sender: TObject);
begin
    if FOpenDialog.Execute() then begin
        edFileName.Text := FOpenDialog.FileName;
    end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
    F: TextFile;
    Stg, stg1, stg2, stg3: string;
    N_Enregistrement
        , Nom_commercial
        , Nom_DCI
        , Dosage
        , Unite
        , Conditionnement
        , Remoursable
        , Date_remboursement
        , date_arret_remboursement
        , Tarif_de_reference
        , Forme
        , Observation: string;
    ALine: string;
    ATimeStart,ATimeEnd:TDateTime;
const
    _Sep = ';';
begin
    ATimeStart:=Now();

    AssignFile(F, edFileName.Text);
    Reset(F);
    repeat
        Readln(F, Stg);

        N_Enregistrement := copy(stg, 1, 5);
        Nom_commercial := copy(stg, 6, 49);
        Nom_DCI := copy(stg, 56, 49);
        Dosage := copy(stg, 106, 28);
        Unite := copy(stg, 136, 19);
        Conditionnement := copy(stg, 156, 20);
        Remoursable := copy(stg, 176, 1);
        Date_remboursement := Copy(Stg, 178, 8);
        date_arret_remboursement := Copy(Stg, 186, 8);
        Tarif_de_reference := copy(stg, 194, 20);
        Forme := copy(stg, 216, 6);
        Observation := copy(stg, 243, 1000);

        if edDisplayData.Checked then
            edData.Lines.Add(Nom_commercial
                + _Sep + Nom_DCI
                + _Sep + Dosage
                + _Sep + Unite
                + _Sep + Conditionnement
                + _Sep + Remoursable
                + _Sep + Date_remboursement
                + _Sep + date_arret_remboursement
                + _Sep + Tarif_de_reference
                + _Sep + Forme
                + _Sep + Observation
                );

    until EOF(F);
    CloseFile(F);

    ATimeEnd:=Now();

    edData.Lines.Add('Debut ' + FormatDateTime('hh:nn:ss:zzz', ATimeStart));
    edData.Lines.Add('Fin : ' + FormatDateTime('hh:nn:ss:zzz', Now));
    ShowMessage(FormatDateTime('hh"h" nn"min" ss"s" zzz',ATimeEnd-ATimeStart));
end;

end.

